#include"utils.h"
#include"spi.c"
#include"lcd.c"
#include"lemon.c"
#include"orange.c"
#include"plum.c"
#include"seven.c"

typedef void (*draw)(unsigned int x, unsigned int y, int ok);

static unsigned int randomizer = 189;
static unsigned int initiated = 0;
static unsigned int sym[6][5];
static unsigned int credit = 1000;
static unsigned int bet = 1;
static unsigned int lines = 5;
static unsigned int winning = 0;
static char str[10];
static unsigned int x[] = {X0, X1, X2, X3, X4};
static unsigned int y[] = {Y0, Y1, Y2, Y3, Y4, Y5};
static draw func[] = {&drawLemon, &drawOrange, &drawPlum, &drawSeven};
static unsigned int prize[] = {10, 10, 10, 50, 25, 10, 10, 10, 25, 10, 
							10, 50, 10, 10, 25, 25, 10, 10};
static unsigned int indices[] = {1, 0, 0, 3, 2, 1, 1, 0, 2, 0, 1, 3, 0, 1, 2, 2, 1, 0};

void printVerticals() {
	lcdDrawVLine(12, 68, 200, RED); lcdDrawVLine(13, 68, 200, RED);
	lcdDrawVLine(14, 68, 200, RED); lcdDrawVLine(15, 68, 200, RED);
	lcdDrawVLine(56, 70, 198, RED);	lcdDrawVLine(57, 70, 198, RED);
	lcdDrawVLine(98, 70, 198, RED);	lcdDrawVLine(99, 70, 198, RED);
	lcdDrawVLine(140, 70, 198, RED); lcdDrawVLine(141, 70, 198, RED);
	lcdDrawVLine(182, 70, 198, RED); lcdDrawVLine(183, 70, 198, RED);
	lcdDrawVLine(224, 68, 200, RED); lcdDrawVLine(225, 68, 200, RED);
	lcdDrawVLine(226, 68, 200, RED); lcdDrawVLine(227, 68, 200, RED);

	lcdDrawHLine(14, 68, 225, RED); lcdDrawHLine(14, 69, 225, RED);
	lcdDrawHLine(14, 70, 225, RED); lcdDrawHLine(14, 71, 225, RED);
	lcdDrawHLine(14, 196, 225, RED); lcdDrawHLine(14, 197, 225, RED);
	lcdDrawHLine(14, 198, 225, RED); lcdDrawHLine(14, 199, 225, RED);
}

void printLines() {
	lcdFilledRec(61, 275, 55, 20, BLACK);
	itoa(lines, str, 10);
	lcdDrawString(str, 65, 275, 2, YELLOW);
}

void printBet() {
	lcdFilledRec(61, 300, 55, 20, BLACK);
	itoa(bet, str, 10);
	lcdDrawString(str, 65, 300, 2, YELLOW);	
}

void printCredit() {
	lcdFilledRec(182, 275, 58, 20, BLACK);
	itoa(credit, str, 10);
	lcdDrawString(str, 186, 275, 2, YELLOW);
}

void printTotalBet() {
	lcdFilledRec(182, 300, 58, 20, BLACK);
	itoa(bet * lines, str, 10);
	lcdDrawString(str, 186, 300, 2, YELLOW);
}

void printWinning() {
	lcdFilledRec(10, 200, 230, 70, BLACK);
	lcdDrawString("You won:", 20, 210, 3, YELLOW);
	itoa(winning, str, 10);
	lcdDrawString(str, 140, 210, 3, YELLOW);
	lcdDrawString("Double??", 60, 245, 3, YELLOW);
}

void printCollect() {
	lcdFilledRec(10, 200, 230, 70, BLACK);
	lcdDrawString("Collect:", 10, 220, 3, YELLOW);
	itoa(winning, str, 10);
	lcdDrawString(str, 120, 220, 3, YELLOW);
}

void init() {
	int i, j;

	if (initiated == 0) {
		DDRD &= ~(3<<PD0);	
		DDRD &= ~(3<<PD4);
		PORTD |= (3<<PD0);
		PORTD |= (3<<PD4);
		DDRB &= ~(1<<PB3);
		PORTB |= (1<<PB3);
		ili9341_init();
	}
	lcdFillRGB(BLACK);
	lcdDrawString("Sizzling Hot",15,20,4,YELLOW);
	lcdFilledRec(16, 72, 207, 124, WHITE);

	printVerticals();

	lcdDrawString("Lines:", 10, 275, 2, YELLOW);
	lcdDrawString("B/L:", 23, 300, 2, YELLOW);
	lcdDrawString("Credit:", 120, 275, 2, YELLOW);
	lcdDrawString("Bet:", 144, 300, 2, YELLOW);

	printLines(); printBet(); printCredit(); printTotalBet();

	for (i = 0; i < 6; i++)
		for (j = 0; j < 5; j++) {
			if (initiated == 0) {
				randomizer = (randomizer * 109 + 89) % 25631;
				sym[i][j] = indices[randomizer % 18];
			}
			(*func[sym[i][j]])(x[j], y[i], 0);
		}

	if (initiated == 0) {
		lcdFilledRec(16, 91, 208, 3, BROWN);	
		lcdFilledRec(16, 91 + 42, 208, 3, DARK_GREEN);	
		lcdFilledRec(16, 91 + 84, 208, 3, CYAN);		
		lcdDrawOLine(15, 72, 119, 196, SILVER);	
		lcdDrawOLine(16, 72, 120, 196, SILVER);
		lcdDrawOLine(17, 72, 121, 196, SILVER);
		lcdDrawOLine(119, 176, 221, 72, SILVER);
		lcdDrawOLine(120, 176, 222, 72, SILVER);
		lcdDrawOLine(121, 176, 223, 72, SILVER);
		lcdDrawOLine(15, 196, 119, 72, BLUE);
		lcdDrawOLine(16, 196, 120, 72, BLUE);
		lcdDrawOLine(17, 196, 121, 72, BLUE);
		lcdDrawOLine(119, 92, 221, 196, BLUE);
		lcdDrawOLine(120, 92, 222, 196, BLUE);
		lcdDrawOLine(121, 92, 223, 196, BLUE);
	}
	initiated = 1;
}

void printInfo() {
	lcdFillRGB(BLACK);
	lcdDrawString("Sizzling Hot",15,20,4,YELLOW);
	lcdDrawString("Prizes",75,70,3,YELLOW);

	lcdFilledRec(50, 106, 40, 40, WHITE);
	drawLemon(50, 106, 1);
	strcpy(str, "3 - ");
	itoa(prize[1] * bet * W3, str + 4, 10);
	lcdDrawString(str, 115, 110, 1, YELLOW);
	strcpy(str, "4 - ");
	itoa(prize[1] * bet * W4, str + 4, 10);
	lcdDrawString(str, 115, 123, 1, YELLOW);
	strcpy(str, "5 - ");
	itoa(prize[1] * bet * W5, str + 4, 10);
	lcdDrawString(str, 115, 136, 1, YELLOW);

	lcdFilledRec(50, 161, 40, 40, WHITE);
	drawOrange(50, 161, 1);
	strcpy(str, "3 - ");
	itoa(prize[0] * bet * W3, str + 4, 10);
	lcdDrawString(str, 115, 165, 1, YELLOW);
	strcpy(str, "4 - ");
	itoa(prize[0] * bet * W4, str + 4, 10);
	lcdDrawString(str, 115, 178, 1, YELLOW);
	strcpy(str, "5 - ");
	itoa(prize[0] * bet * W5, str + 4, 10);
	lcdDrawString(str, 115, 191, 1, YELLOW);
	
	lcdFilledRec(50, 216, 40, 40, WHITE);
	drawPlum(50, 216, 1);
	strcpy(str, "3 - ");
	itoa(prize[4] * bet * W3, str + 4, 10);
	lcdDrawString(str, 115, 220, 1, YELLOW);
	strcpy(str, "4 - ");
	itoa(prize[4] * bet * W4, str + 4, 10);
	lcdDrawString(str, 115, 233, 1, YELLOW);
	strcpy(str, "5 - ");
	sprintf(str + 4, "%u", prize[4] * bet * W5, str + 4, 10);
	lcdDrawString(str, 115, 249, 1, YELLOW);
	
	lcdFilledRec(50, 271, 40, 40, WHITE);
	drawSeven(50, 271, 1);
	strcpy(str, "3 - ");
	itoa(prize[3] * bet * W3,str + 4,  10);
	lcdDrawString(str, 115, 275, 1, YELLOW);
	strcpy(str, "4 - ");
	itoa(prize[3] * bet * W4, str + 4, 10);
	lcdDrawString(str, 115, 288, 1, YELLOW);
	strcpy(str, "5 - ");
	sprintf(str + 4, "%u", prize[3] * bet * W5, str + 4, 10);
	lcdDrawString(str, 115, 301, 1, YELLOW);

	while (1) {
		if ((PINB & (1 << PB3)) == 0) {
			init();
			_delay_ms(200);
			break;
		}
	}
}

void checkWinning1(unsigned int line, uint16_t color) {
	if (sym[line][0] == sym[line][1] && sym[line][2] == sym[line][1]) {
		if (sym[line][3] == sym[line][1]) {
			if (sym[line][4] == sym[line][1]) {
				lcdFilledRec(16, 91 + 42 * (line - 3), 208, 3, color);
				winning += bet * W5 * prize[sym[line][0]];
			}
			else {
				lcdFilledRec(16, 91 + 42 * (line - 3), 166, 3, color);
				winning += bet * W4 * prize[sym[line][0]];
			}
		}
		else {
			lcdFilledRec(16, 91 + 42 * (line - 3), 124, 3, color);
			winning += bet * W3 * prize[sym[line][0]];
		}
	}
}

void checkWinning3() {
	checkWinning1(3, BROWN); checkWinning1(5, CYAN);
}

void checkWinning5() {
	if (sym[3][0] == sym[4][1] && sym[5][2] == sym[4][1]) {
		lcdDrawOLine(15, 72, 119, 196, SILVER);
		lcdDrawOLine(16, 72, 120, 196, SILVER);
		lcdDrawOLine(17, 72, 121, 196, SILVER);
		if (sym[4][3] == sym[4][1]) {
			if (sym[3][4] == sym[4][1]) {
				lcdDrawOLine(119, 176, 221, 72, SILVER);
				lcdDrawOLine(120, 176, 222, 72, SILVER);
				lcdDrawOLine(121, 176, 223, 72, SILVER);
				winning += bet * W5 * prize[sym[3][0]];
			}
			else {
				lcdDrawOLine(119, 176, 161, 134, SILVER);
				lcdDrawOLine(120, 176, 162, 134, SILVER);
				lcdDrawOLine(121, 176, 163, 134, SILVER);
				winning += bet * W4 * prize[sym[3][0]];
			}
		}
		else winning += bet * W3 * prize[sym[3][0]];
	}	

	if (sym[5][0] == sym[4][1] && sym[3][2] == sym[4][1]) {
		lcdDrawOLine(15, 196, 119, 72, BLUE);
		lcdDrawOLine(16, 196, 120, 72, BLUE);
		lcdDrawOLine(17, 196, 121, 72, BLUE);
		if (sym[4][3] == sym[4][1]) {
			if (sym[5][4] == sym[4][1]) {
				lcdDrawOLine(119, 92, 221, 196, BLUE);
				lcdDrawOLine(120, 92, 222, 196, BLUE);
				lcdDrawOLine(121, 92, 223, 196, BLUE);
				winning += bet * W5 * prize[sym[5][0]];
			}
			else {
				lcdDrawOLine(119, 92, 161, 134, BLUE);
				lcdDrawOLine(120, 92, 162, 134, BLUE);
				lcdDrawOLine(121, 92, 163, 134, BLUE);
				winning += bet * W4 * prize[sym[5][0]];
			}
		}
		else winning += bet * W3 * prize[sym[5][0]];
	}	
}

void rotate() {
	int i, j, k;

	credit -= bet * lines;
	printCredit();

	for (j = 0; j < 5; j++)
		for (k = 0; k < 129; k++) 
			for (i = 0; i < 6; i++) {
				(*func[sym[i][j]])(x[j], y[i] + k, 0);
			}

	for (j = 0; j < 5; j++) {
		for (i = 0; i < 3; i++) {
			randomizer = (randomizer * 109 + 89) % 5631;
			sym[i + 3][j] = sym[i][j];
			sym[i][j] = indices[randomizer % 18];
		}
	}

	switch (lines) {
		case 5: checkWinning5();
		case 3: checkWinning3();
		case 1: checkWinning1(4, DARK_GREEN);
	}
}

void finish_win() {
	char aux[2];

	lcdFilledRec(10, 210, 230, 60, RED);
	lcdDrawString("CASH OUT",20,220,3,YELLOW);
	lcdDrawString("You won:",20,250,2,YELLOW);
	sprintf(str, "%d, %d lei", credit / 100, credit % 100);
	lcdDrawString(str,100,250,2,YELLOW);
	while (1);
}

void finish_lose() {
	lcdFilledRec(10, 210, 230, 60, RED);
	lcdDrawString("You lose!",20, 220, 3, YELLOW);
	lcdDrawString("Please, insert coin!",20,250,2,YELLOW);
	while (1);
}

void tryDouble() {
	int rando, chosen;

	lcdFillRGB(BLACK);
	lcdDrawString("Sizzling Hot",15,20,4,YELLOW);
	lcdDrawString("Pick Orange or Plum:",30,70,2,YELLOW);
	lcdDrawString("Prize:",20,200,3,YELLOW);
	itoa(winning, str, 10);
	lcdDrawString(str,100,200,3,YELLOW);

	while (1) {		
		chosen = 0;
		randomizer = (randomizer * 109 + 89) % 5631;
		rando = randomizer % 2 + 1;

		if (winning > 30000 || (PIND & (1 << PD5)) == 0) {
			credit += winning;
			init();
			printCollect();
			
			_delay_ms(20);
			break;
		}

		if (winning > 0) {
			if ((PIND & (1 << PD0)) == 0) {
				chosen = 1;
				_delay_ms(200);	
			}
			else if ((PIND & (1 << PD1)) == 0) {
				chosen = 2;	
				_delay_ms(200);	
			}
			
			if (chosen) {
				lcdFilledRec(100, 120, 40, 40, WHITE);
				(*func[rando])(100, 120, 1);

				if (chosen == rando) {
					winning *= 2;
					lcdFilledRec(98, 200, 90, 40, BLACK);
					itoa(winning, str, 10);
					lcdDrawString(str,100,200,3,YELLOW);
					lcdFilledRec(10, 248, 210, 60, BLACK);
					lcdDrawString("You doubled!", 40, 250, 3, GREEN);
				}
				else {
					winning = 0;
					lcdFilledRec(98, 200, 210, 90, BLACK);
					itoa(winning, str, 10);
					lcdDrawString(str,100,200,3,YELLOW);
					lcdFilledRec(10, 248, 210, 60, BLACK);
					lcdDrawString("You lost!", 60, 250, 3, RED);
				}
			}
		}
	}
}

int main()
{
	init();
	lcdDrawString("PLAY!", 80, 225, 3, YELLOW);

	while(1) {
		if ((PINB & (1 << PB3)) == 0) {
			printInfo();
		}

		if ((PIND & (1 << PD0)) == 0) {
			if (credit >= 5 * bet)
				lines = (lines + 2) % 6;
			else if (credit >= 3 * bet)
				lines = (lines + 2) % 4;
			printLines();printTotalBet();
			_delay_ms(300);
		}

		if ((PIND & (1 << PD1)) == 0) {
			if (bet == 25 && credit >= 4 * bet * lines)
				bet *= 4;
			else if (bet == 100)
				bet = 1;
			else if (credit >= 5 * bet * lines)
				bet = bet * 5;
			else bet = 1;	
			printBet(); printTotalBet();
			_delay_ms(300);
		}

		if ((PIND & (1 << PD5)) == 0) {
			printVerticals();
			rotate();
			_delay_ms(20);
			if (winning > 0) {
				printWinning();
				while (1) {
					if ((PIND & (1 << PD5)) == 0) {
						credit += winning;
						printCredit();
						printCollect();
						_delay_ms(200);
						break;
					}			
					if ((PIND & (1 << PD4)) == 0) {
						tryDouble();
						_delay_ms(20);
						break;
					}
				}
			}
			if (winning == 0) {
				lcdFilledRec(10, 200, 230, 70, BLACK);
				lcdDrawString("PLAY!", 80, 225, 3, YELLOW);
			}
			winning = 0;
			if (credit == 0) finish_lose();
			while (credit < bet * lines) {
				if (lines > 1) lines -= 2;
				else if (bet == 100) bet = 25;
				else if (bet == 25 || bet == 5) bet /= 5;
			}
			printLines(); printBet(); printTotalBet();
		}

		if (credit > 30000 || (PIND & (1 << PD4)) == 0) {
			finish_win();
			_delay_ms(20);
		}
	}
	return 0;
}